public class Cable implements Connection<PowerSupply> {
    private int strands;
    private PowerSupply source, sink;

    // pre: strands has to be > 0
    public Cable(int strands) { this.strands = strands; }

    // post : returns the source which belongs to cable
    public PowerSupply source() { return this.source; }

    // post : returns the sink which belongs to cable
    public PowerSupply sink() { return this.sink; }

    // post : returns the property of cable
    public float property() {
        return strands();
    }

    //pre : source != null
    //post : set the cables source
    public void setsource(PowerSupply source) { this.source = source; }

    //pre : sink != null
    //post : set the cables sink
    public void setsink(PowerSupply sink) { this.sink = sink; }

    //post : returns the strands value
    public float strands() { return this.strands; }

    //"Cable: source.toString() => sink.toString()"
    public String toString() {
        String res = "Cable (strands " + this.strands +  ") : ";
        res += this.source != null ? this.source.toString() : "null";
        res += " => ";
        res += this.sink != null ? this.sink.toString() : "null";
        return res;
    }
}
