public class Hose implements Connection<WaterSupply> {
    private float diameter;
    private WaterSupply source, sink;

    // pre: diameter has to be > 0
    public Hose(float diameter) { this.diameter = diameter; }

    // post : returns the source which belongs to Hose
    public WaterSupply source() { return this.source; };

    // post : returns the sink which belongs to Hose
    public WaterSupply sink() { return this.sink; }

    // post : returns the property of hose
    public float property() {
        return diameter();
    }

    //pre : source != null
    //post : set the hoses source
    public void setsource(WaterSupply source) { this.source = source; }

    //pre : source != null
    //post : set the hoses sink
    public void setsink(WaterSupply sink) { this.sink = sink; }

    //post : returns diameter value of this hose
    public float diameter() { return this.diameter; }

    //"Hose: source.toString() => sink.toString()"
    public String toString() {
        String res = "Hose (diameter " + this.diameter +  "): ";
        res += this.source != null ? this.source.toString() : "null";
        res += " => ";
        res += this.sink != null ? this.sink.toString() : "null";
        return res;
    }
}
