/*
  EXERCISE 5:
  ================================================================================
  Design a program to enable enable Connections of different kinds of Supplies and
  compose Compositions of those Connections and Supplies. Basically a framework of
  Connections, Supplies and Containers for those.
  =============================Work distribution==================================
  ================================================================================
 */

import java.util.Iterator;

public class Test {
    public static void main(String[] args) {

        firstTC();
        secondTc();
        thirdTC();
        //rmTest();
    }

    private static void firstTC() {
        System.out.println("####################################   first Testcase   ####################################");
        //Definitions of objects we need for the test
        Ensemble<String> stringEnsemble = new Ensemble<>();
        Negator intNeg = new Negator();

        WaterSupply w = new WaterSupply("WSource");
        WaterSupply ws = new WaterSupply("WSink");
        WaterSupply ws2 = new WaterSupply("W2Sink");
        Hose h = new Hose(6.66f);
        Composition<WaterSupply, Hose> wshComp = new Composition<>("WSHComp");

        PowerSupply p = new PowerSupply("PSource");
        PowerSupply ps = new PowerSupply("PSink");
        PowerSupply p2 = new PowerSupply("P2Source");
        Cable c = new Cable(2);
        Cable c2 = new Cable(6);
        Composition<PowerSupply, Cable> pscComp = new Composition<>("PSCComp");

        Composition<Composition<WaterSupply, Hose>, ? extends Connection<Composition<WaterSupply,Hose>>> weirdComp = new Composition<>("WeirdComp");

        //Negation Test
        System.out.println("Negation Test: ");
        System.out.println("Initial State of Negator: " + intNeg);
        System.out.println("Setting Source to 6");
        intNeg.setsource(6);
        System.out.println("Result State: " + intNeg);
        System.out.println();

        //Add tests
        System.out.println("Add Tests");
        //Ensemble Test Add
        System.out.println("Ensemble<String> Add Tests");
        System.out.println("Initial State of Ensemble: " + stringEnsemble);
        System.out.println("Adding TestString");
        stringEnsemble.add("TestString");
        System.out.println("Adding AnotherTest");
        stringEnsemble.add("AnotherTest");
        System.out.println("Result State: " + stringEnsemble);
        System.out.println();

        //Initializing WaterComposition Add Test
        //Source/Sink Setting Test
        System.out.println("Initializing WaterComp Add Test");
        System.out.println("Hose Initial State: " + h);
        System.out.println("Setting Hose Source to " + w);
        h.setsource(w);
        System.out.println("Setting Hose Sink to " + ws);
        h.setsink(ws);
        System.out.println("Result State: " + h);
        System.out.println();

        //WaterComposition Add Test
        System.out.println("WaterComposition Add Test");
        System.out.println("Initial State: " + wshComp);
        System.out.println("Connecting to WaterComp: " + h);
        wshComp.connect(h);
        System.out.println("Result State: " + wshComp);
        System.out.println("Adding: " + ws2);
        wshComp.add(ws2);
        System.out.println("Adding: " + ws);
        wshComp.add(ws);
        System.out.println("Result State: " + wshComp);
        System.out.println();

        //Initializing PowerComposition Add Test
        //Source/Sink Setting Test
        System.out.println("Initializing PowerComp Add Test");
        System.out.println("Cable Initial State: " + c);
        System.out.println("Setting Cable Source to " + p);
        c.setsource(p);
        System.out.println("Setting Cable Sink to " + ps);
        c.setsink(ps);
        System.out.println("Result State Cable: " + c);
        System.out.println("Cable2 Initial State: " + c2);
        System.out.println("Setting Cable Source to " + p2);
        c2.setsource(p2);
        System.out.println("Result State Cable2: " + c2);
        System.out.println();

        //PowerComposition Add Test
        System.out.println("PowerComposition Add Test");
        System.out.println("Initial State: " + pscComp);
        System.out.println("Connecting to PowerComp: " + c);
        pscComp.connect(c);
        System.out.println("Result State: " + pscComp);
        System.out.println("Connecting to PowerComp: " + c2);
        pscComp.connect(c2);
        System.out.println("Result State: " + pscComp);
        System.out.println();

        //Comp<Comp,Comp> Add Test
        System.out.println("Composition<Composition<PowerSupply,Cable>, Composition<WaterSupply,Hose>> Add Test");
        System.out.println("Initial State: " + weirdComp);
        System.out.println("Adding WaterComp " + wshComp);
        weirdComp.add(wshComp);
        System.out.println("Result State: " + weirdComp);
        System.out.println("Connecting PowerComp " + pscComp);
        weirdComp.compConnect(pscComp);
        System.out.println("Result State: " + weirdComp);
        System.out.println();

        System.out.println("Iterating over PowerComp Connections:");
        System.out.println("Initial State: " + pscComp);
        Iterator<Connection<? extends PowerSupply>> powIter = pscComp.connectionIter();
        System.out.println("Searching and removing Cable with strands of 6");
        System.out.println();

        //BUG Ensemble cant handle removing and then adding back in
        while(powIter.hasNext()) {
            Connection con = powIter.next();
            System.out.println("At elem: " + con);
            if(con.property() == 6) {
                System.out.println("Removing elem: " + con);
                powIter.remove();
            }
        }
        System.out.println("Result State: " + pscComp);
        System.out.println("Adding the connection back in twice");
        pscComp.connect(c2);
        pscComp.connect(c2);
        System.out.println("Result State: " + pscComp);
        System.out.println();

        System.out.println("Collecting all strands from PowerComp");
        powIter = pscComp.connectionIter();
        float val = 0;
        System.out.println("Starting Iteration");
        while(powIter.hasNext()) {
            Connection con = powIter.next();
            System.out.println("At powercon elem: " + con);
            System.out.println("Adding " + con.property() + " to total of " + val);
            val += con.property();
        }
        System.out.println("Total of " + val + " strands");
        System.out.println();

        System.out.println("Collecting all diameters from WaterComp");
        Iterator<Connection<? extends WaterSupply>> waterIter = wshComp.connectionIter();
        val = 0;
        System.out.println("Starting Iteration");
        while(waterIter.hasNext()) {
            Connection con = waterIter.next();
            System.out.println("At watercon elem: " + con);
            System.out.println("Adding " + con.property() + " to total of " + val);
            val += con.property();
        }
        System.out.println("Total of " + val + " diameters");
    }

    private static void secondTc(){
        System.out.println("\n####################################   second Testcase   ####################################");
        WaterSupply w = new WaterSupply("WSource");
        WaterSupply ws = new WaterSupply("WSink");
        WaterSupply ws2 = new WaterSupply("W2Sink");
        Hose h = new Hose(6.66f);
        Composition<WaterSupply, Hose> wshComp = new Composition<>("WSHComp");

        PowerSupply p = new PowerSupply("PSource");
        PowerSupply ps = new PowerSupply("PSink");
        PowerSupply p2 = new PowerSupply("P2Source");
        Cable c = new Cable(2);
        Cable c2 = new Cable(6);
        Composition<PowerSupply, Cable> pscComp = new Composition<>("PSCComp");

        h.setsource(w);
        h.setsink(ws);

        wshComp.connect(h);

        wshComp.add(ws2);
        wshComp.add(ws);

        c.setsource(p);
        c.setsink(ps);
        c2.setsource(p2);

        pscComp.connect(c);
        pscComp.connect(c2);

        System.out.println("Composition<Supply,Connection<Supply>>");
        Composition<Supply,Connection<Supply>> supComp = new Composition<>("supComp");

        Iterator<Connection<? extends WaterSupply>> waterIter = wshComp.connectionIter();
        Iterator<Connection<? extends PowerSupply>> powerIter = pscComp.connectionIter();

        System.out.println("Starting to add 'supComp' connections ");
        System.out.println("Adding water supplies");
        while(waterIter.hasNext()){
            Connection<? extends Supply> con = waterIter.next();
            System.out.println("Adding new Connection : " + con);
            supComp.connect(con);
        }
        System.out.println("Finished adding water supplies");
        System.out.println("Adding power supplies");
        while(powerIter.hasNext()){
            Connection<? extends Supply> con = powerIter.next();
            System.out.println("Adding new Connection : " + con);
            supComp.connect(con);
        }
        System.out.println("Finished adding power supplies");

        System.out.println("Result State : " + supComp);

        Iterator<Connection<? extends Supply>> supIter = supComp.connectionIter();
        System.out.println("Start to removing elements");
        while(supIter.hasNext()){
            Connection con = supIter.next();
            System.out.println("At elem : " + con);
            supIter.remove();
        }
        System.out.println("Result State : " + supComp);

    }

    private static void thirdTC() {
        System.out.println("\n####################################   third Testcase   ####################################");

        //Duplicate Code from TC2 for init
        WaterSupply w = new WaterSupply("WSource");
        WaterSupply ws = new WaterSupply("WSink");
        WaterSupply ws2 = new WaterSupply("W2Sink");
        Hose h = new Hose(6.66f);
        Composition<WaterSupply, Hose> wshComp = new Composition<>("WSHComp");
        PowerSupply p = new PowerSupply("PSource");
        PowerSupply ps = new PowerSupply("PSink");
        PowerSupply p2 = new PowerSupply("P2Source");
        Cable c = new Cable(2);
        Cable c2 = new Cable(6);
        Composition<PowerSupply, Cable> pscComp = new Composition<>("PSCComp");
        h.setsource(w);
        h.setsink(ws);
        wshComp.connect(h);
        wshComp.add(ws2);
        wshComp.add(ws);
        c.setsource(p);
        c.setsink(ps);
        c2.setsource(p2);
        pscComp.connect(c);
        pscComp.connect(c2);
        Composition<Supply,Connection<Supply>> supComp = new Composition<>("SupplyComp");
        Iterator<Connection<? extends WaterSupply>> waterIter = wshComp.connectionIter();
        Iterator<Connection<? extends PowerSupply>> powerIter = pscComp.connectionIter();
        while(waterIter.hasNext()){
            supComp.connect(waterIter.next());
        }
        while(powerIter.hasNext()){
            supComp.connect(powerIter.next());
        }

        System.out.println("Casting Composition<Supply,Connection<Supply>> SupplyComp to Ensemble<Supply>");
        Ensemble<Supply> supens = supComp;
        System.out.println("Initial State Ensemble<Supply>: " + supens);
        System.out.println();
        System.out.println("Trying to add duplicate PowerSupply: " + p2);
        supens.add(p2);
        System.out.println("Result State of Ensemble<Supply>: " + supens);
        System.out.println();
        System.out.println("Iterating over Supplies");
        for (Supply supen : supens) {
            System.out.println("At elem: " + supen);
        }
        System.out.println();
        System.out.println("Removing all elems out of Ensemble now");
        System.out.println("Initial State: " + supens);
        Iterator<Supply> supiter = supens.iterator();
        while(supiter.hasNext()) {
            supiter.next();
            supiter.remove();
        }
        System.out.println("Result State of Ensemble<Supply>: " + supens);
        System.out.println("Result State of Composition<Supply,Connection<Supply>> SupplyComp: " + supComp);
    }

    private static void rmTest() {

		Ensemble<String> stringEnsemble = new Ensemble<>(true);
		//Add tests
		System.out.println("Add Tests:");
		//Ensemble Test Add
		System.out.println("Ensemble<String> Add Tests: ");
		System.out.println("Initial State of Ensemble: " + stringEnsemble);
		/*System.out.println("Adding TestString");
		stringEnsemble.add("TestString");
		System.out.println("Adding AnotherTest");
		System.out.println("Adding AnotherTest");
		System.out.println("Adding AnotherTest");
		stringEnsemble.add("AnotherTest");
		stringEnsemble.add("AnotherTest");
		stringEnsemble.add("AnotherTest");*/
		System.out.println("Adding a");
		String ma = "a";
		stringEnsemble.add(ma);
		System.out.println("Adding b");
		stringEnsemble.add("b");
		System.out.println("Result State: " + stringEnsemble);

		//remove test
		System.out.println("\nRemove test:");
		System.out.println("Before remove of a" + stringEnsemble);
		Iterator<String> sIter = stringEnsemble.iterator();
		while (sIter.hasNext()) {
            if(sIter.next().equals(ma)){
                sIter.remove();
            }
			if(sIter.next().equals("b")){
				sIter.remove();
			}
		}
		sIter.remove();
        stringEnsemble.add(ma);
		stringEnsemble.add(ma);
		stringEnsemble.add(ma);
		sIter = stringEnsemble.iterator();
		while (sIter.hasNext()) {
			String test = sIter.next();
			if (test.equals(ma)) {
				sIter.remove();
			}
		}

		System.out.println("Result State: " + stringEnsemble);
	}
}
